#include <X11/keysym.h>

#include "gtdisplay.h"
#include "gtgc.h"
#include "gtwindow.h"
#include "gtpixmap.h"
#include "gtcolormap.h"


int xd[8]={1,1,0,-1,-1,-1,0,1},yd[8]={0,-1,-1,-1,0,1,1,1};
int ox=0,oy=0,od=0;

void DrawPos(GtGC *gcd,GtGC *gcc,GtWindow *win,int xp,int yp,int d)
{
	gcc->DrawLine(win,ox+5+5*xd[od],oy+5+5*yd[od],
		ox+5+5*xd[(od+2)&7],oy+5+5*yd[(od+2)&7]);
	gcc->DrawLine(win,ox+5+5*xd[od],oy+5+5*yd[od],
		ox+5+5*xd[(od-2)&7],oy+5+5*yd[(od-2)&7]);
	xp*=11;
	yp*=11;
	ox=xp;
	oy=yp;
	od=d;
	gcd->DrawLine(win,ox+5+5*xd[od],oy+5+5*yd[od],
		ox+5+5*xd[(od+2)&7],oy+5+5*yd[(od+2)&7]);
	gcd->DrawLine(win,ox+5+5*xd[od],oy+5+5*yd[od],
		ox+5+5*xd[(od-2)&7],oy+5+5*yd[(od-2)&7]);
}

int main(void)
{
	GtDisplay *dsp;
	GtWindow *win;
	GtGC *gcd,*gcc;
	GtPixmap *pix;
	XEvent *xe;
	KeySym ks;
	int go=1,xp=0,yp=0,d=0;
	int nr,n;
	
	dsp=GtMkDisplay(NULL);
	win=GtMkWindow(dsp,
		GT_XSize,220,
		GT_YSize,220,
		GT_BackPixel,0,
		GT_EventMask,ExposureMask|KeyPressMask,
		GT_DONE);
	gcd=GtMkGC(dsp,
		GT_Drawable,win,
		GT_Foreground,1,
		GT_Background,0,
		GT_DONE);
	gcc=GtMkGC(dsp,
		GT_Foreground,0,
		GT_Background,1,
		GT_DONE);
	win->Map(TRUE);
	while(go)
	{
		xe=dsp->HandleEvent();
		if(xe)
		{
			switch(xe->type)
			{
				case Expose:
					DrawPos(gcd,gcc,win,xp,yp,d);
					break;
				case KeyPress:
					ks=XKeycodeToKeysym(dsp->XDsp(),xe->xkey.keycode,0);
					switch(ks)
					{
						case XK_Escape:
							go=0;
							break;
						case XK_Left:
							d=(d+1)&7;
							DrawPos(gcd,gcc,win,xp,yp,d);
							break;
						case XK_Right:
							d=(d-1)&7;
							DrawPos(gcd,gcc,win,xp,yp,d);
							break;
						case XK_Up:
							if((xp+xd[d]>=0) && (xp+xd[d]<20) && (yp+yd[d]>=0) && (yp+yd[d]<20))
							{
								xp+=xd[d];
								yp+=yd[d];
								DrawPos(gcd,gcc,win,xp,yp,d);
							}
							break;
						case XK_Down:
							if((xp-xd[d]>=0) && (xp-xd[d]<20) && (yp-yd[d]>=0) && (yp-yd[d]<20))
							{
								xp-=xd[d];
								yp-=yd[d];
								DrawPos(gcd,gcc,win,xp,yp,d);
							}
							break;
					}
					break;
			}
		}
	}
	delete gcd;
	delete gcc;
	delete win;
	delete dsp;
}
